<script lang="ts">
import GetStartedAccordion from './accordion.vue';

export default {
  name: 'GetStartedFaq',
  components: { GetStartedAccordion },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      groupsData: { visible: false, groups: [] },
      currentHash: '',
    };
  },
  mounted() {
    this.groupsData.groups = this.data.groups.map(
      (group: any, index: number) => ({
        ...group,
        visible: !index,
        items: group.items.map((item: any) => ({
          ...item,
          expanded: false,
        })),
      }),
    );
  },
  methods: {
    getShowAll(group: any) {
      return group.items.some((item: any) => !item.expanded);
    },
    toggleGroup(index: number, newState: boolean): void {
      const selectedGroup = this.groupsData.groups[index] as any;
      selectedGroup.items = selectedGroup.items.map((question: any) => ({
        ...question,
        expanded: newState,
      }));
    },
    toggleItems(groupIndex: number, itemIndex: number) {
      const selectedQuestion = (this.groupsData.groups[groupIndex] as any)
        .items[itemIndex];
      selectedQuestion.expanded = !selectedQuestion.expanded;
    },
  },
};
</script>

<template>
  <section>
    <div
      v-for="(group, index) in groupsData.groups"
      :id="group.id"
      :key="index"
      class="get-started-steps slp-mb-64 slp-mb-md-96"
    >
      <div class="get-started-steps__gradient-header" />
      <SlpRow class="get-started-steps__header">
        <div class="get-started-steps__header__anchor">
          <SlpTypography tag="h1" variant="heading1-bold"
            >{{ group.header }}
          </SlpTypography>
          <router-link :to="{ path: '', hash: group.id }" data-test="ty">
            <SlpIcon
              class="slp-ml-16"
              name="anchor"
              variant="marketing"
              slp-color="text-link-100"
              alt="Anchor Icon"
            />
          </router-link>
        </div>
        <button
          v-if="getShowAll(group)"
          type="button"
          class="get-started-steps__header__action"
          :data-toggle-group="group.header"
          @click="toggleGroup(index, true)"
        >
          <SlpTypography
            variant="body3-bold"
            role="button"
            :aria-label="`Expand all ${group.header} items.`"
          >
            Show All
          </SlpTypography>
        </button>
        <button
          v-else
          class="get-started-steps__header__action"
          type="button"
          tabindex="0"
          :aria-label="`Close all ${group.header} items.`"
          @click="toggleGroup(index, false)"
        >
          <SlpTypography variant="body3-bold"> Hide All</SlpTypography>
        </button>
      </SlpRow>
      <SlpRow
        v-for="(item, itemIndex) in group.items"
        :key="`${item.header}-${itemIndex}`"
      >
        <GetStartedAccordion
          :data="item"
          :item-index="itemIndex"
          @toggleController="toggleItems(index, itemIndex)"
        />
      </SlpRow>
    </div>
  </section>
</template>

<style scoped lang="scss">
.get-started-steps {
  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
  }

  &__header {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    padding-bottom: $spacing-32;
    padding-top: $spacing-16;

    @media (min-width: $breakpoint-md) {
      align-items: center;
    }

    &__anchor {
      display: flex;
      align-items: center;
      max-width: 50%;

      @media (min-width: $breakpoint-md) {
        max-width: 100%;
      }

      &::v-deep .slp-icon {
        opacity: 1;
        transition: opacity 0.5s ease-in-out;
        @media (min-width: $breakpoint-md) {
          opacity: 0;
        }
      }

      &:hover {
        &::v-deep .slp-icon {
          opacity: 1;
        }
      }
    }

    &__action {
      border: none;
      color: $color-text-link-100;
      transition: all 0.5s ease-in-out;
      cursor: pointer;

      &:hover {
        filter: brightness(80%);
        text-decoration: underline;
      }
    }
  }
}
</style>
